Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 52564)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 52567)
@@ -1008,6 +1008,7 @@
 
 
-    /* Separator #1? */
-    bool fSeparator1 = false;
+    /* Separator? */
+    bool fSeparator = false;
+
 
     /* 'Contents' action: */
@@ -1019,5 +1020,5 @@
         connect(action(UIActionIndex_Simple_Contents), SIGNAL(triggered()),
                 &msgCenter(), SLOT(sltShowHelpHelpDialog()), Qt::UniqueConnection);
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -1030,14 +1031,15 @@
         connect(action(UIActionIndex_Simple_WebSite), SIGNAL(triggered()),
                 &msgCenter(), SLOT(sltShowHelpWebDialog()), Qt::UniqueConnection);
-        fSeparator1 = true;
-    }
-
-    /* Separator #1: */
-    if (fSeparator1)
+        fSeparator = true;
+    }
+
+
+    /* Separator? */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
-
-
-    /* Separator #2? */
-    bool fSeparator2 = false;
+        fSeparator = false;
+    }
+
 
     /* 'Reset Warnings' action: */
@@ -1049,18 +1051,17 @@
         connect(action(UIActionIndex_Simple_ResetWarnings), SIGNAL(triggered()),
                 &msgCenter(), SLOT(sltResetSuppressedMessages()), Qt::UniqueConnection);
-        fSeparator2 = true;
-    }
-
-    /* Separator #2: */
-    if (fSeparator2)
+        fSeparator = true;
+    }
+
+
+    /* Separator? */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
+        fSeparator = false;
+    }
 
 
 #ifdef VBOX_GUI_WITH_NETWORK_MANAGER
-# ifndef Q_WS_MAC
-    /* Separator #3? */
-    bool fSeparator3 = false;
-# endif /* !Q_WS_MAC */
-
     /* 'Network Manager' action: */
     const bool fAllowToShowActionNetworkManager = isAllowedInMenuHelp(UIExtraDataMetaDefs::MenuHelpActionType_NetworkAccessManager);
@@ -1071,7 +1072,5 @@
         connect(action(UIActionIndex_Simple_NetworkAccessManager), SIGNAL(triggered()),
                 gNetworkManager, SLOT(show()), Qt::UniqueConnection);
-# ifndef Q_WS_MAC
-        fSeparator3 = true;
-# endif /* !Q_WS_MAC */
+        fSeparator = true;
     }
 
@@ -1087,15 +1086,15 @@
             connect(action(UIActionIndex_Simple_CheckForUpdates), SIGNAL(triggered()),
                     gUpdateManager, SLOT(sltForceCheck()), Qt::UniqueConnection);
-# ifndef Q_WS_MAC
-            fSeparator3 = true;
-# endif /* !Q_WS_MAC */
+            fSeparator = true;
         }
     }
 
-# ifndef Q_WS_MAC
-    /* Separator #3: */
-    if (fSeparator3)
+
+    /* Separator? */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
-# endif /* !Q_WS_MAC */
+        fSeparator = false;
+    }
 #endif /* VBOX_GUI_WITH_NETWORK_MANAGER */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 52564)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 52567)
@@ -2026,6 +2026,7 @@
 
 
-    /* Separator #1? */
-    bool fSeparator1 = false;
+    /* Separator: */
+    bool fSeparator = false;
+
 
     /* 'Settings Dialog' action: */
@@ -2035,5 +2036,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_Settings));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2044,5 +2045,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_TakeSnapshot));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2053,5 +2054,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_TakeScreenshot));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2062,14 +2063,15 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_ShowInformation));
-        fSeparator1 = true;
-    }
-
-    /* Separator #1: */
-    if (fSeparator1)
+        fSeparator = true;
+    }
+
+
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
-
-
-    /* Separator #2? */
-    bool fSeparator2 = false;
+        fSeparator = false;
+    }
+
 
     /* 'Keyboard' submenu: */
@@ -2079,5 +2081,5 @@
     {
 //        pMenu->addAction(action(UIActionIndexRT_M_Machine_M_Keyboard));
-//        fSeparator2 = true;
+//        fSeparator = true;
     }
     updateMenuMachineKeyboard();
@@ -2089,5 +2091,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_M_Keyboard_S_Settings));
-        fSeparator2 = true;
+        fSeparator = true;
     }
 
@@ -2098,5 +2100,5 @@
     {
 //        pMenu->addAction(action(UIActionIndexRT_M_Machine_M_Mouse));
-//        fSeparator2 = true;
+//        fSeparator = true;
     }
     updateMenuMachineMouse();
@@ -2108,14 +2110,15 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_M_Mouse_T_Integration));
-        fSeparator2 = true;
-    }
-
-    /* Separator #2: */
-    if (fSeparator2)
+        fSeparator = true;
+    }
+
+
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
-
-
-    /* Separator #3? */
-    bool fSeparator3 = false;
+        fSeparator = false;
+    }
+
 
     /* 'Type CAD' action: */
@@ -2125,5 +2128,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_TypeCAD));
-        fSeparator3 = true;
+        fSeparator = true;
     }
 
@@ -2135,15 +2138,16 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_TypeCABS));
-        fSeparator3 = true;
+        fSeparator = true;
     }
 #endif /* Q_WS_X11 */
 
-    /* Separator #3: */
-    if (fSeparator3)
+
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
-
-
-    /* Separator #4? */
-    bool fSeparator4 = false;
+        fSeparator = false;
+    }
+
 
     /* 'Pause' action: */
@@ -2153,5 +2157,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_T_Pause));
-        fSeparator4 = true;
+        fSeparator = true;
     }
 
@@ -2162,5 +2166,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_Reset));
-        fSeparator4 = true;
+        fSeparator = true;
     }
 
@@ -2171,5 +2175,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_Save));
-        fSeparator4 = true;
+        fSeparator = true;
     }
 
@@ -2180,5 +2184,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_Shutdown));
-        fSeparator4 = true;
+        fSeparator = true;
     }
 
@@ -2189,15 +2193,17 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Machine_S_PowerOff));
-        fSeparator4 = true;
-    }
+        fSeparator = true;
+    }
+
 
 #ifndef Q_WS_MAC
-    /* Separator #4: */
-    if (fSeparator4)
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
-#endif /* !Q_WS_MAC */
-
-
-#ifndef Q_WS_MAC
+        fSeparator = false;
+    }
+
+
     /* Close action: */
     const bool fAllowToShowActionClose = isAllowedInMenuMachine(UIExtraDataMetaDefs::RuntimeMenuMachineActionType_Close);
@@ -2256,31 +2262,43 @@
 
 
-    /* Visual representation mode flags: */
+    /* Separator: */
+    bool fSeparator = false;
+
+
+    /* 'Fullscreen' action: */
     const bool fIsAllowToShowActionFullscreen = isAllowedInMenuView(UIExtraDataMetaDefs::RuntimeMenuViewActionType_Fullscreen);
-    const bool fIsAllowToShowActionSeamless   = isAllowedInMenuView(UIExtraDataMetaDefs::RuntimeMenuViewActionType_Seamless);
-    const bool fIsAllowToShowActionScale      = isAllowedInMenuView(UIExtraDataMetaDefs::RuntimeMenuViewActionType_Scale);
-
-    /* 'Fullscreen' action: */
     action(UIActionIndexRT_M_View_T_Fullscreen)->setEnabled(fIsAllowToShowActionFullscreen);
     if (fIsAllowToShowActionFullscreen)
+    {
         pMenu->addAction(action(UIActionIndexRT_M_View_T_Fullscreen));
+        fSeparator = true;
+    }
 
     /* 'Seamless' action: */
+    const bool fIsAllowToShowActionSeamless   = isAllowedInMenuView(UIExtraDataMetaDefs::RuntimeMenuViewActionType_Seamless);
     action(UIActionIndexRT_M_View_T_Seamless)->setEnabled(fIsAllowToShowActionSeamless);
     if (fIsAllowToShowActionSeamless)
+    {
         pMenu->addAction(action(UIActionIndexRT_M_View_T_Seamless));
+        fSeparator = true;
+    }
 
     /* 'Scale' action: */
+    const bool fIsAllowToShowActionScale      = isAllowedInMenuView(UIExtraDataMetaDefs::RuntimeMenuViewActionType_Scale);
     action(UIActionIndexRT_M_View_T_Scale)->setEnabled(fIsAllowToShowActionScale);
     if (fIsAllowToShowActionScale)
+    {
         pMenu->addAction(action(UIActionIndexRT_M_View_T_Scale));
-
-    /* Visual representation mode separator: */
-    if (fIsAllowToShowActionFullscreen || fIsAllowToShowActionSeamless || fIsAllowToShowActionScale)
+        fSeparator = true;
+    }
+
+
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
-
-
-    /* Separator #1? */
-    bool fSeparator1 = false;
+        fSeparator = false;
+    }
+
 
     /* 'Adjust Window' action: */
@@ -2290,5 +2308,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_View_S_AdjustWindow));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2299,14 +2317,15 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_View_T_GuestAutoresize));
-        fSeparator1 = true;
-    }
-
-    /* Separator #1: */
-    if (fSeparator1)
+        fSeparator = true;
+    }
+
+
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
-
-
-    /* Separator #2? */
-    bool fSeparator2 = false;
+        fSeparator = false;
+    }
+
 
     /* 'Menu Bar' submenu: */
@@ -2316,5 +2335,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_View_M_MenuBar));
-        fSeparator2 = true;
+        fSeparator = true;
     }
     updateMenuViewMenuBar();
@@ -2326,11 +2345,15 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_View_M_StatusBar));
-        fSeparator2 = true;
+        fSeparator = true;
     }
     updateMenuViewStatusBar();
 
-    /* Separator #2: */
-    if (fSeparator2)
+
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
+        fSeparator = false;
+    }
 
 
@@ -2379,6 +2402,7 @@
 
 
-    /* Separator #1? */
-    bool fSeparator1 = false;
+    /* Separator: */
+    bool fSeparator = false;
+
 
     /* 'Adjust Window' action: */
@@ -2388,5 +2412,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_View_S_AdjustWindow));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2397,10 +2421,14 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_View_T_GuestAutoresize));
-        fSeparator1 = true;
-    }
-
-    /* Separator #1: */
-    if (fSeparator1)
+        fSeparator = true;
+    }
+
+
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
+        fSeparator = false;
+    }
 
 
@@ -2594,6 +2622,7 @@
 
 
-    /* Separator #1? */
-    bool fSeparator1 = false;
+    /* Separator: */
+    bool fSeparator = false;
+
 
     /* 'Hard Drives' submenu: */
@@ -2603,5 +2632,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_HardDrives));
-        fSeparator1 = true;
+        fSeparator = true;
     }
     updateMenuDevicesHardDrives();
@@ -2613,5 +2642,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_OpticalDevices));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2622,5 +2651,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_FloppyDevices));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2631,5 +2660,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_Network));
-        fSeparator1 = true;
+        fSeparator = true;
     }
     updateMenuDevicesNetwork();
@@ -2641,5 +2670,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_USBDevices));
-        fSeparator1 = true;
+        fSeparator = true;
     }
     updateMenuDevicesUSBDevices();
@@ -2651,5 +2680,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_WebCams));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2660,5 +2689,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_SharedClipboard));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2669,5 +2698,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_DragAndDrop));
-        fSeparator1 = true;
+        fSeparator = true;
     }
 
@@ -2678,15 +2707,16 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_SharedFolders));
-        fSeparator1 = true;
+        fSeparator = true;
     }
     updateMenuDevicesSharedFolders();
 
-    /* Separator #1: */
-    if (fSeparator1)
+
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
-
-
-    /* Separator #2? */
-    bool fSeparator2 = false;
+        fSeparator = false;
+    }
+
 
     /* 'VRDE Server' action: */
@@ -2696,5 +2726,5 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_T_VRDEServer));
-        fSeparator2 = true;
+        fSeparator = true;
     }
 
@@ -2705,11 +2735,15 @@
     {
         pMenu->addAction(action(UIActionIndexRT_M_Devices_M_VideoCapture_T_Start));
-        fSeparator2 = true;
+        fSeparator = true;
     }
     updateMenuDevicesVideoCapture();
 
-    /* Separator #2: */
-    if (fSeparator2)
+
+    /* Separator: */
+    if (fSeparator)
+    {
         pMenu->addSeparator();
+        fSeparator = false;
+    }
 
 